#滑动窗口 + 单调队列# 2018 Multi-University Training Contest 3 Problem A. Ascending Rating

版权声明:本文为博主原创文章,转载清注明出处 https://blog.csdn.net/Jasmineaha/article/details/81628014

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=6319

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i-th contestant's QodeForces rating is ai.
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m, say [l,l+m−1], and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1and count=0. Everytime he meets a contestant k with strictly higher rating than maxrating, he will change maxrating to ak and count to count+1.
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count. Please write a program to figure out the answer.

Input

The first line of the input contains an integer T(1≤T≤2000), denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD.
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109), denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :ai=(p×ai−1+q×i+r)modMOD。
It is guaranteed that ∑n≤7×107 and ∑k≤2×106.

 Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1].
For each test case, you need to print a single line containing two integers A and B, where :

AB==∑i=1n−m+1(maxratingi⊕i)∑i=1n−m+1(counti⊕i)
Note that ``⊕'' denotes binary XOR operation.

Sample Input

1 10 6 10 5 5 5 5 3 2 2 1 5 7 6 8 2 9

 Sample Output

46 11

Description:

从 1 到 n-m+1 分别为起点的连续的长度为 m 的区间中,以区间起点为开始的上升序列的长度和最大值

Solution:

滑动窗口 + 单调队列。

如果当前元素比栈顶元素大,则不断弹出栈顶元素直到当前元素比栈顶元素小,然后把当前元素压入栈中。如果当前元素比栈顶元素小,则直接入栈。如果当前栈中有元素不在当前区间中,则不断弹出栈底元素。每段区间最大值就是栈底元素,递增序列的长度就是栈的大小。

Code:

#include <cstdio>
#include <cstring>
#include <string>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
#define mst(a, b) memset(a, b, sizeof(a))
using namespace std;
typedef long long LL;
typedef pair<int, int> PII;
const int INF = 0x3f3f3f3f;
const double eps = 1e-9;
const int MaxN = 1e7 + 5;

LL a[MaxN];
int pos[MaxN];
int n, m;
LL ans, res;

void solve() {
	for(int i = 0; i <= n; i++) pos[i] = 0;
	ans = res = 0;
	int l = 1, r = 0;
	for(int i = n; i >= 1; i--) {
		while(r >= l && a[pos[r]] <= a[i]) r--;
		pos[++r] = i;
		if(i + m - 1 > n) continue;
		while(r >= l && pos[l] > i + m - 1) l++;
		ans += a[pos[l]] ^ i;
		res += (r - l + 1) ^ i;
	}
}

int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    
    int t; cin >> t;
    while(t--) {
		int k, p, q, r, mod;
		cin >> n >> m >> k >> p >> q >> r >> mod;
		for(int i = 1; i <= k; i++) cin >> a[i];
		for(int i = k + 1; i <= n; i++) {
			LL tmp = (p * a[i-1] + (LL)q * i + r) % mod;
			a[i] = tmp;
		}
		solve();
		cout << ans << " " << res << endl;
	}
    return 0;
}

猜你喜欢

转载自blog.csdn.net/Jasmineaha/article/details/81628014